package sun.swing.plaf.synth;

import java.awt.Component;
import java.awt.Graphics;
import javax.swing.plaf.synth.SynthContext;
import javax.swing.Icon;

public abstract class SynthIcon implements Icon
{
    public SynthIcon() {
    }
    
    public static int getIconWidth(Icon icon, SynthContext synthContext) {
        if (icon == null) {
            return 0;
        }
        if ((icon instanceof SynthIcon)) {
            return ((SynthIcon)icon).getIconWidth(synthContext);
        }
        return icon.getIconWidth();
    }
    
    public static int getIconHeight(Icon icon, SynthContext synthContext) {
        if (icon == null) {
            return 0;
        }
        if ((icon instanceof SynthIcon)) {
            return ((SynthIcon)icon).getIconHeight(synthContext);
        }
        return icon.getIconHeight();
    }
    
    public static void paintIcon(Icon icon, SynthContext synthContext, Graphics graphics, int n, int n2, int n3, int n4) {
        if ((icon instanceof SynthIcon)) {
            ((SynthIcon)icon).paintIcon(synthContext, graphics, n, n2, n3, n4);
        }
        else if (icon != null) {
            icon.paintIcon(synthContext.getComponent(), graphics, n, n2);
        }
    }
    
    public abstract void paintIcon(SynthContext p0, Graphics p1, int p2, int p3, int p4, int p5);
    
    public abstract int getIconWidth(SynthContext p0);
    
    public abstract int getIconHeight(SynthContext p0);
    
    @Override
    public void paintIcon(Component component, Graphics graphics, int n, int n2) {
        this.paintIcon(null, graphics, n, n2, 0, 0);
    }
    
    @Override
    public int getIconWidth() {
        return this.getIconWidth(null);
    }
    
    @Override
    public int getIconHeight() {
        return this.getIconHeight(null);
    }
}
